]> git.notmuchmail.org Git - notmuch/blob - test/test-lib.sh
emacs: Add new option notmuch-search-hide-excluded
[notmuch] / test / test-lib.sh
1 #
2 # Copyright (c) 2005 Junio C Hamano
3 # Copyright (c) 2010 Notmuch Developers
4 #
5 # This program is free software: you can redistribute it and/or modify
6 # it under the terms of the GNU General Public License as published by
7 # the Free Software Foundation, either version 2 of the License, or
8 # (at your option) any later version.
9 #
10 # This program is distributed in the hope that it will be useful,
11 # but WITHOUT ANY WARRANTY; without even the implied warranty of
12 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
13 # GNU General Public License for more details.
14 #
15 # You should have received a copy of the GNU General Public License
16 # along with this program.  If not, see https://www.gnu.org/licenses/ .
17
18 if [ ${BASH_VERSINFO[0]} -lt 4 ]; then
19     echo "Error: The notmuch test suite requires a bash version >= 4.0"
20     echo "due to use of associative arrays within the test suite."
21     echo "Please try again with a newer bash (or help us fix the"
22     echo "test suite to be more portable). Thanks."
23     exit 1
24 fi
25
26 # Make sure echo builtin does not expand backslash-escape sequences by default.
27 shopt -u xpg_echo
28
29 # Ensure NOTMUCH_SRCDIR and NOTMUCH_BUILDDIR are set.
30 . $(dirname "$0")/export-dirs.sh || exit 1
31
32 # We need either a built tree, or a promise of an installed notmuch
33 if [ -z "${NOTMUCH_TEST_INSTALLED-}" -a ! -x "$NOTMUCH_BUILDDIR/notmuch" ]; then
34         echo >&2 'You do not seem to have built notmuch yet.'
35         exit 1
36 fi
37
38 this_test=${0##*/}
39 this_test=${this_test%.sh}
40 this_test_bare=${this_test#T[0-9][0-9][0-9]-}
41
42 # if --tee was passed, write the output not only to the terminal, but
43 # additionally to the file test-results/$BASENAME.out, too.
44 case "$GIT_TEST_TEE_STARTED, $* " in
45 done,*)
46         # do not redirect again
47         ;;
48 *' --tee '*|*' --va'*)
49         mkdir -p test-results
50         BASE=test-results/$this_test
51         (GIT_TEST_TEE_STARTED=done "$BASH" "$0" "$@" 2>&1;
52          echo $? > $BASE.exit) | tee $BASE.out
53         test "$(cat $BASE.exit)" = 0
54         exit
55         ;;
56 esac
57
58 # STDIN from /dev/null. EOF for readers (and ENOTTY for tty related ioctls).
59 exec </dev/null
60
61 # Save STDOUT to fd 6 and STDERR to fd 7.
62 exec 6>&1 7>&2
63 # Make xtrace debugging (when used) use redirected STDERR, with verbose lead:
64 BASH_XTRACEFD=7
65 export PS4='+(${BASH_SOURCE}:${LINENO}): ${FUNCNAME[0]:+${FUNCNAME[0]}(): }'
66
67 . "$NOTMUCH_SRCDIR/test/test-vars.sh" || exit 1
68
69 add_gnupg_home () {
70     [ -e "${GNUPGHOME}/gpg.conf" ] && return
71     _gnupg_exit () { gpgconf --kill all 2>/dev/null || true; }
72     at_exit_function _gnupg_exit
73     mkdir -p -m 0700 "$GNUPGHOME"
74     gpg --no-tty --import <$NOTMUCH_SRCDIR/test/openpgp4-secret-key.asc >"$GNUPGHOME"/import.log 2>&1
75     test_debug "cat $GNUPGHOME/import.log"
76     if (gpg --quick-random --version >/dev/null 2>&1) ; then
77         echo quick-random >> "$GNUPGHOME"/gpg.conf
78     elif (gpg --debug-quick-random --version >/dev/null 2>&1) ; then
79         echo debug-quick-random >> "$GNUPGHOME"/gpg.conf
80     fi
81     echo no-emit-version >> "$GNUPGHOME"/gpg.conf
82
83     # Change this if we ship a new test key
84     FINGERPRINT="9A3AFE6C60065A148FD4B58A7E6ABE924645CC60"
85     SELF_USERID="Notmuch Test Suite (INSECURE!) <test_suite@notmuchmail.org>"
86     SELF_EMAIL="test_suite@notmuchmail.org"
87     printf '%s:6:\n' "$FINGERPRINT" | gpg --quiet --batch --no-tty --import-ownertrust
88 }
89
90 add_gpgsm_home () {
91     test_require_external_prereq openssl
92
93     local fpr
94     [ -e "$GNUPGHOME/gpgsm.conf" ] && return
95     _gnupg_exit () { gpgconf --kill all 2>/dev/null || true; }
96     at_exit_function _gnupg_exit
97     mkdir -p -m 0700 "$GNUPGHOME"
98     gpgsm --batch --no-tty --no-common-certs-import --pinentry-mode=loopback --passphrase-fd 3 \
99           --disable-dirmngr --import  >"$GNUPGHOME"/import.log 2>&1 3<<<'' <$NOTMUCH_SRCDIR/test/smime/0xE0972A47.p12
100     fpr=$(gpgsm --batch --with-colons --list-key test_suite@notmuchmail.org | awk -F: '/^fpr/ {print $10}')
101     echo "$fpr S relax" >> "$GNUPGHOME/trustlist.txt"
102     gpgsm --quiet --batch --no-tty --no-common-certs-import --disable-dirmngr --import < $NOTMUCH_SRCDIR/test/smime/ca.crt
103     echo "4D:E0:FF:63:C0:E9:EC:01:29:11:C8:7A:EE:DA:3A:9A:7F:6E:C1:0D S" >> "$GNUPGHOME/trustlist.txt"
104     printf '%s::1\n' include-certs disable-crl-checks | gpgconf --output /dev/null --change-options gpgsm
105     gpgsm --batch --no-tty --no-common-certs-import --pinentry-mode=loopback --passphrase-fd 3 \
106               --disable-dirmngr --import "$NOTMUCH_SRCDIR/test/smime/bob.p12" >>"$GNUPGHOME"/import.log 2>&1 3<<<''
107     test_debug "cat $GNUPGHOME/import.log"
108 }
109
110 # Each test should start with something like this, after copyright notices:
111 #
112 # test_description='Description of this test...
113 # This test checks if command xyzzy does the right thing...
114 # '
115 # . ./test-lib.sh || exit 1
116
117 color=maybe
118
119 while test "$#" -ne 0
120 do
121         case "$1" in
122         -d|--debug)
123                 debug=t; shift ;;
124         -i|--immediate)
125                 immediate=t; shift ;;
126         -h|--help)
127                 help=t; shift ;;
128         -v|--verbose)
129                 verbose=t; shift ;;
130         -q|--quiet)
131                 quiet=t; shift ;;
132         --with-dashes)
133                 with_dashes=t; shift ;;
134         --no-color)
135                 color=; shift ;;
136         --no-python)
137                 # noop now...
138                 shift ;;
139         --valgrind)
140                 valgrind=t; verbose=t; shift ;;
141         --tee)
142                 shift ;; # was handled already
143         *)
144                 echo "error: unknown test option '$1'" >&2; exit 1 ;;
145         esac
146 done
147
148 if test -n "$debug"; then
149         fmt_subtest () {
150                 printf -v $1 " %-4s" "[$((test_count - 1))]"
151         }
152 else
153         fmt_subtest () {
154                 printf -v $1 ''
155         }
156 fi
157
158 test -n "$COLORS_WITHOUT_TTY" || [ -t 1 ] || color=
159
160 if [ -n "$color" ] && [ "$ORIGINAL_TERM" != 'dumb' ] &&
161         tput -T "$ORIGINAL_TERM" -S <<<$'bold\nsetaf\nsgr0\n' >/dev/null 2>&1
162 then
163         color=t
164 else
165         color=
166 fi
167
168 if test -n "$color"
169 then
170         # _tput run in subshell (``) only
171         _tput () { exec tput -T "$ORIGINAL_TERM" "$@"; }
172         unset BOLD RED GREEN BROWN SGR0
173         say_color () {
174                 case "$1" in
175                         error)  b=${BOLD=`_tput bold`}
176                                 c=${RED=`_tput setaf 1`}   ;; # bold red
177                         skip)   b=${BOLD=`_tput bold`}
178                                 c=${GREEN=`_tput setaf 2`} ;; # bold green
179                         pass)   b= c=${GREEN=`_tput setaf 2`} ;; # green
180                         info)   b= c=${BROWN=`_tput setaf 3`} ;; # brown
181                         *) b= c=; test -n "$quiet" && return ;;
182                 esac
183                 f=$2
184                 shift 2
185                 sgr0=${SGR0=`_tput sgr0`}
186                 fmt_subtest st
187                 printf " ${b}${c}${f}${sgr0}${st}" "$@"
188         }
189 else
190         say_color() {
191                 test -z "$1" && test -n "$quiet" && return
192                 f=$2
193                 shift 2
194                 fmt_subtest st
195                 printf " ${f}${st}" "$@"
196         }
197 fi
198
199 error () {
200         say_color error "error: $*\n"
201         GIT_EXIT_OK=t
202         exit 1
203 }
204
205 say () {
206         say_color info "$*"
207 }
208
209 test "${test_description}" != "" ||
210 error "Test script did not set test_description."
211
212 if test "$help" = "t"
213 then
214         echo "Tests ${test_description}"
215         exit 0
216 fi
217
218 test_description_printed=
219 print_test_description () {
220         test -z "$test_description_printed" || return 0
221         echo
222         echo $this_test: "Testing ${test_description}"
223         test_description_printed=1
224 }
225 if [ -z "$NOTMUCH_TEST_QUIET" ]
226 then
227         print_test_description
228 fi
229
230 test_failure=0
231 test_count=0
232 test_fixed=0
233 test_broken=0
234 test_success=0
235
236 declare -a _exit_functions=()
237
238 at_exit_function () {
239         _exit_functions=($1 ${_exit_functions[@]/$1})
240 }
241
242 rm_exit_function () {
243         _exit_functions=(${_exit_functions[@]/$1})
244 }
245
246 _exit_common () {
247         code=$?
248         trap - EXIT
249         set +ex
250         for _fn in ${_exit_functions[@]}; do $_fn; done
251         rm -rf "$TEST_TMPDIR"
252 }
253
254 trap_exit () {
255         _exit_common
256         if test -n "$GIT_EXIT_OK"
257         then
258                 exit $code
259         else
260                 exec >&6
261                 say_color error '%-6s' FATAL
262                 echo " $test_subtest_name"
263                 echo
264                 echo "Unexpected exit while executing $0. Exit code $code."
265                 exit 1
266         fi
267 }
268
269 trap_signal () {
270         _exit_common
271         echo >&6 "FATAL: $0: interrupted by signal" $((code - 128))
272         exit $code
273 }
274
275 die () {
276         _exit_common
277         exec >&6
278         say_color error '%-6s' FATAL
279         echo " $*"
280         echo
281         echo "Unexpected exit while executing $0."
282         exit 1
283 }
284
285 trap 'trap_exit' EXIT
286 trap 'trap_signal' HUP INT TERM
287
288 # Add an existing, fixed corpus of email to the database.
289 #
290 # $1 is the corpus dir under corpora to add, using "default" if unset.
291 #
292 # The default corpus is based on about 50 messages from early in the
293 # history of the notmuch mailing list, which allows for reliably
294 # testing commands that need to operate on a not-totally-trivial
295 # number of messages.
296 add_email_corpus () {
297     local corpus
298     corpus=${1:-default}
299
300     rm -rf ${MAIL_DIR}
301     cp -a $NOTMUCH_SRCDIR/test/corpora/$corpus ${MAIL_DIR}
302     notmuch new >/dev/null || die "'notmuch new' failed while adding email corpus"
303 }
304
305 test_begin_subtest () {
306     if [ -n "$inside_subtest" ]; then
307         exec 1>&6 2>&7          # Restore stdout and stderr
308         error "bug in test script: Missing test_expect_equal in ${BASH_SOURCE[1]}:${BASH_LINENO[0]}"
309     fi
310     test_subtest_name="$1"
311     test_reset_state_
312     # Redirect test output to the previously prepared file descriptors
313     # 3 and 4 (see below)
314     if test "$verbose" != "t"; then exec 4>test.output 3>&4; fi
315     exec >&3 2>&4
316     inside_subtest=t
317 }
318
319 # Pass test if two arguments match
320 #
321 # Note: Unlike all other test_expect_* functions, this function does
322 # not accept a test name. Instead, the caller should call
323 # test_begin_subtest before calling this function in order to set the
324 # name.
325 test_expect_equal () {
326         local output expected testname
327         exec 1>&6 2>&7          # Restore stdout and stderr
328         if [ -z "$inside_subtest" ]; then
329                 error "bug in the test script: test_expect_equal without test_begin_subtest"
330         fi
331         inside_subtest=
332         test "$#" = 2 ||
333         error "bug in the test script: not 2 parameters to test_expect_equal"
334
335         output="$1"
336         expected="$2"
337         if ! test_skip "$test_subtest_name"
338         then
339                 if [ "$output" = "$expected" ]; then
340                         test_ok_
341                 else
342                         testname=$this_test.$test_count
343                         echo "$expected" > $testname.expected
344                         echo "$output" > $testname.output
345                         test_failure_ "$(diff -u $testname.expected $testname.output)"
346                 fi
347     fi
348 }
349
350 test_diff_file_ () {
351     local file1 file2 testname basename1 basename2
352     file1="$1"
353     file2="$2"
354     if ! test_skip "$test_subtest_name"
355     then
356         if diff -q "$file1" "$file2" >/dev/null ; then
357             test_ok_
358         else
359             testname=$this_test.$test_count
360             basename1=`basename "$file1"`
361             basename2=`basename "$file2"`
362             cp "$file1" "$testname.$basename1"
363             cp "$file2" "$testname.$basename2"
364             test_failure_ "$(diff -u "$testname.$basename1" "$testname.$basename2")"
365         fi
366     fi
367 }
368
369 # Like test_expect_equal, but takes two filenames.
370 test_expect_equal_file () {
371     exec 1>&6 2>&7              # Restore stdout and stderr
372     if [ -z "$inside_subtest" ]; then
373         error "bug in the test script: test_expect_equal_file without test_begin_subtest"
374     fi
375     inside_subtest=
376     test "$#" = 2 ||
377         error "bug in the test script: not 2 parameters to test_expect_equal_file"
378
379     test_diff_file_ "$1" "$2"
380 }
381
382 # Like test_expect_equal_file, but compare the part of the two files after the first blank line
383 test_expect_equal_message_body () {
384     exec 1>&6 2>&7              # Restore stdout and stderr
385     if [ -z "$inside_subtest" ]; then
386         error "bug in the test script: test_expect_equal_file without test_begin_subtest"
387     fi
388     test "$#" = 2 ||
389         error "bug in the test script: not 2 parameters to test_expect_equal_file"
390
391     for file in "$1" "$2"; do
392         if [ ! -s "$file" ]; then
393             test_failure_ "Missing or zero length file: $file"
394             inside_subtest=
395             return 1
396         fi
397     done
398
399     expected=$(sed '1,/^$/d' "$1")
400     output=$(sed '1,/^$/d' "$2")
401     test_expect_equal "$expected" "$output"
402 }
403
404 # Like test_expect_equal, but takes two filenames. Fails if either is empty
405 test_expect_equal_file_nonempty () {
406     exec 1>&6 2>&7              # Restore stdout and stderr
407     if [ -z "$inside_subtest" ]; then
408         error "bug in the test script: test_expect_equal_file_nonempty without test_begin_subtest"
409     fi
410     inside_subtest=
411     test "$#" = 2 ||
412         error "bug in the test script: not 2 parameters to test_expect_equal_file_nonempty"
413
414     for file in "$1" "$2"; do
415         if [ ! -s "$file" ]; then
416             test_failure_ "Missing or zero length file: $file"
417             return $?
418         fi
419     done
420
421     test_diff_file_ "$1" "$2"
422 }
423
424 # Like test_expect_equal, but arguments are JSON expressions to be
425 # canonicalized before diff'ing.  If an argument cannot be parsed, it
426 # is used unchanged so that there's something to diff against.
427 test_expect_equal_json () {
428     local script output expected
429     # The test suite forces LC_ALL=C, but this causes Python 3 to
430     # decode stdin as ASCII.  We need to read JSON in UTF-8, so
431     # override Python's stdio encoding defaults.
432     script='import json, sys; json.dump(json.load(sys.stdin), sys.stdout, sort_keys=True, indent=4)'
433     output=$(echo "$1" | PYTHONIOENCODING=utf-8 $NOTMUCH_PYTHON -c "$script" \
434         || echo "$1")
435     expected=$(echo "$2" | PYTHONIOENCODING=utf-8 $NOTMUCH_PYTHON -c "$script" \
436         || echo "$2")
437     shift 2
438     test_expect_equal "$output" "$expected" "$@"
439 }
440
441 # Ensure that the argument is valid JSON data.
442 test_valid_json () {
443     PYTHONIOENCODING=utf-8 $NOTMUCH_PYTHON -c "import sys, json; json.load(sys.stdin)" <<<"$1"
444     test_expect_equal "$?" 0
445 }
446
447 # Sort the top-level list of JSON data from stdin.
448 test_sort_json () {
449     PYTHONIOENCODING=utf-8 $NOTMUCH_PYTHON -c \
450         "import sys, json; json.dump(sorted(json.load(sys.stdin)),sys.stdout)"
451 }
452
453 # test for json objects:
454 # read the source of test/json_check_nodes.py (or the output when
455 # invoking it without arguments) for an explanation of the syntax.
456 test_json_nodes () {
457         local output
458         exec 1>&6 2>&7          # Restore stdout and stderr
459         if [ -z "$inside_subtest" ]; then
460                 error "bug in the test script: test_json_eval without test_begin_subtest"
461         fi
462         inside_subtest=
463         test "$#" > 0 ||
464             error "bug in the test script: test_json_nodes needs at least 1 parameter"
465
466         if ! test_skip "$test_subtest_name"
467         then
468             output=$(PYTHONIOENCODING=utf-8 $NOTMUCH_PYTHON -B "$NOTMUCH_SRCDIR"/test/json_check_nodes.py "$@")
469                 if [ "$?" = 0 ]
470                 then
471                         test_ok_
472                 else
473                         test_failure_ "$output"
474                 fi
475         fi
476 }
477
478 NOTMUCH_NEW () {
479     notmuch new "${@}" | grep -v -E -e '^Processed [0-9]*( total)? file|Found [0-9]* total file'
480 }
481
482 NOTMUCH_DUMP_TAGS () {
483     # this relies on the default format being batch-tag, otherwise some tests will break
484     notmuch dump --include=tags "${@}" | sed '/^#/d' | sort
485 }
486
487 notmuch_drop_mail_headers () {
488     $NOTMUCH_PYTHON -c '
489 import email, sys
490 msg = email.message_from_file(sys.stdin)
491 for hdr in sys.argv[1:]: del msg[hdr]
492 print(msg.as_string(False))
493 ' "$@"
494 }
495
496 notmuch_debug_sanitize () {
497     grep -v '^D.:'
498 }
499
500 notmuch_exception_sanitize () {
501     perl -pe 's,(A Xapian exception occurred at) .*?([^/]*[.]cc?):([0-9]*),\1 \2:XXX,'
502 }
503
504 notmuch_search_sanitize () {
505     notmuch_debug_sanitize | perl -pe 's/("?thread"?: ?)("?)................("?)/\1\2XXX\3/'
506 }
507
508 notmuch_search_files_sanitize () {
509     notmuch_dir_sanitize |  sed 's/msg-[0-9][0-9][0-9]/msg-XXX/'
510 }
511
512 notmuch_dir_sanitize () {
513     sed -e "s,$MAIL_DIR,MAIL_DIR," -e "s,${PWD},CWD,g" "$@"
514 }
515
516 NOTMUCH_SHOW_FILENAME_SQUELCH='s,filename:.*/mail,filename:/XXX/mail,'
517 notmuch_show_sanitize () {
518     sed -e "$NOTMUCH_SHOW_FILENAME_SQUELCH"
519 }
520 notmuch_show_sanitize_all () {
521     notmuch_debug_sanitize | \
522     sed \
523         -e 's| filename:.*| filename:XXXXX|' \
524         -e 's| id:[^ ]* | id:XXXXX |' | \
525         notmuch_date_sanitize
526 }
527
528 notmuch_json_show_sanitize () {
529     sed \
530         -e 's|"id": "[^"]*",|"id": "XXXXX",|g' \
531         -e 's|"Date": "Fri, 05 Jan 2001 [^"]*0000"|"Date": "GENERATED_DATE"|g' \
532         -e 's|"filename": "signature.asc",||g' \
533         -e 's|"duplicate": 1,||g' \
534         -e 's|"filename": \["/[^"]*"\],|"filename": \["YYYYY"\],|g' \
535         -e 's|"timestamp": 97.......|"timestamp": 42|g' \
536         -e 's|"content-length": [1-9][0-9]*|"content-length": "NONZERO"|g'
537 }
538
539 notmuch_sexp_show_sanitize () {
540     sed \
541         -e 's|:id "[^"]*"|:id "XXXXX"|g' \
542         -e 's|:Date "Sat, 01 Jan 2000 [^"]*0000"|:Date "GENERATED_DATE"|g' \
543         -e 's|:filename "signature.asc"||g' \
544         -e 's|:duplicate 1 ||g' \
545         -e 's|:filename ("/[^"]*")|:filename ("YYYYY")|g' \
546         -e 's|:timestamp 9........|:timestamp 42|g' \
547         -e 's|:content-length [1-9][0-9]*|:content-length "NONZERO"|g'
548 }
549
550 notmuch_sexp_search_sanitize () {
551     sed -e 's|:thread "[^"]*"|:thread "XXX"|'
552 }
553
554 notmuch_emacs_error_sanitize () {
555     local command
556     command=$1
557     shift
558     for file in "$@"; do
559         echo "=== $file ==="
560         notmuch_debug_sanitize < "$file"
561     done | sed \
562         -e '/^$/d' \
563         -e '/^\[.*\]$/d' \
564         -e "s|^\(command: \)\{0,1\}/.*/$command|\1YYY/$command|"
565 }
566
567 notmuch_date_sanitize () {
568     sed \
569         -e 's/^Date: Fri, 05 Jan 2001 .*0000/Date: GENERATED_DATE/'
570 }
571
572 # remove redundant parts of notmuch-git internal paths
573 notmuch_git_sanitize () {
574     sed  -e 's,tags/\([0-9a-f]\{2\}/\)\{2\},,' -e '/FORMAT/d'
575 }
576 notmuch_uuid_sanitize () {
577     sed 's/[0-9a-f]\{8\}-[0-9a-f]\{4\}-[0-9a-f]\{4\}-[0-9a-f]\{4\}-[0-9a-f]\{12\}/UUID/g'
578 }
579
580 notmuch_built_with_sanitize () {
581     sed 's/^built_with[.]\(.*\)=.*$/built_with.\1=something/'
582 }
583
584 notmuch_config_sanitize () {
585     notmuch_dir_sanitize | notmuch_built_with_sanitize
586 }
587
588 notmuch_show_part () {
589     awk '/^\014part}/{ f=0 }; { if (f) { print $0 } } /^\014part{ ID: '"$1"'/{ f=1 }'
590 }
591
592 # End of notmuch helper functions
593
594 # Use test_set_prereq to tell that a particular prerequisite is available.
595 #
596 # The prerequisite can later be checked for by using test_have_prereq.
597 #
598 # The single parameter is the prerequisite tag (a simple word, in all
599 # capital letters by convention).
600
601 test_set_prereq () {
602         satisfied="$satisfied$1 "
603 }
604 satisfied=" "
605
606 test_have_prereq () {
607         case $satisfied in
608         *" $1 "*)
609                 : yes, have it ;;
610         *)
611                 ! : nope ;;
612         esac
613 }
614
615 declare -A test_missing_external_prereq_
616 declare -A test_subtest_missing_external_prereq_
617
618 # declare prerequisite for the given external binary
619 test_declare_external_prereq () {
620         local binary
621         binary="$1"
622         test "$#" = 2 && name=$2 || name="$binary(1)"
623
624         if ! hash $binary 2>/dev/null; then
625                 test_missing_external_prereq_["${binary}"]=t
626                 eval "
627 $binary () {
628         test_subtest_missing_external_prereq_[\"${name}\"]=t
629         false
630 }"
631         fi
632 }
633
634 # You are not expected to call test_ok_ and test_failure_ directly, use
635 # the text_expect_* functions instead.
636
637 test_ok_ () {
638         if test "$test_subtest_known_broken_" = "t"; then
639                 test_known_broken_ok_
640                 return
641         fi
642         test_success=$(($test_success + 1))
643         if test -n "$NOTMUCH_TEST_QUIET"; then
644                 return 0
645         fi
646         say_color pass "%-6s" "PASS"
647         echo " $test_subtest_name"
648 }
649
650 test_failure_ () {
651         print_test_description
652         if test "$test_subtest_known_broken_" = "t"; then
653                 test_known_broken_failure_ "$@"
654                 return
655         fi
656         test_failure=$(($test_failure + 1))
657         test_failure_message_ "FAIL" "$test_subtest_name" "$@"
658         test "$immediate" = "" || { GIT_EXIT_OK=t; exit 1; }
659         return 1
660 }
661
662 test_failure_message_ () {
663         say_color error "%-6s" "$1"
664         echo " $2"
665         shift 2
666         if [ "$#" != "0" ]; then
667                 echo "$@" | sed -e 's/^/        /'
668         fi
669         if test "$verbose" != "t"; then cat test.output; fi
670 }
671
672 test_known_broken_ok_ () {
673         test_reset_state_
674         test_fixed=$(($test_fixed+1))
675         say_color pass "%-6s" "FIXED"
676         echo " $test_subtest_name"
677 }
678
679 test_known_broken_failure_ () {
680         test_reset_state_
681         test_broken=$(($test_broken+1))
682         if [ -z "$NOTMUCH_TEST_QUIET" ]; then
683                 test_failure_message_ "BROKEN" "$test_subtest_name" "$@"
684         else
685                 test_failure_message_ "BROKEN" "$test_subtest_name"
686         fi
687         return 1
688 }
689
690 test_debug () {
691         test "$debug" = "" || eval "$1"
692 }
693
694 test_run_ () {
695         test_cleanup=:
696         if test "$verbose" != "t"; then exec 4>test.output 3>&4; fi
697         eval >&3 2>&4 "$1"
698         eval_ret=$?
699         eval >&3 2>&4 "$test_cleanup"
700         return 0
701 }
702
703 test_skip () {
704         test_count=$(($test_count+1))
705         to_skip=
706         for skp in $NOTMUCH_SKIP_TESTS
707         do
708                 case $this_test.$test_count in
709                 $skp)
710                         to_skip=t
711                         break
712                 esac
713                 case $this_test_bare.$test_count in
714                 $skp)
715                         to_skip=t
716                         break
717                 esac
718         done
719         case "$to_skip" in
720         t)
721                 test_report_skip_ "$@"
722                 ;;
723         *)
724                 test_check_missing_external_prereqs_ "$@"
725                 ;;
726         esac
727 }
728
729 test_check_missing_external_prereqs_ () {
730         if [[ ${#test_subtest_missing_external_prereq_[@]} != 0 ]]; then
731                 say_color skip >&1 "missing prerequisites: "
732                 echo ${!test_subtest_missing_external_prereq_[@]} >&1
733                 test_report_skip_ "$@"
734         else
735                 false
736         fi
737 }
738
739 test_report_skip_ () {
740         test_reset_state_
741         say_color skip >&3 "skipping test:"
742         echo " $@" >&3
743         say_color skip "%-6s" "SKIP"
744         echo " $1"
745 }
746
747 test_subtest_known_broken () {
748         test_subtest_known_broken_=t
749 }
750
751 test_subtest_broken_for_installed () {
752     if [ -n "${NOTMUCH_TEST_INSTALLED-}" ]; then
753         test_subtest_known_broken_=t
754     fi
755 }
756
757 test_subtest_broken_for_root () {
758    if [ "$EUID" = "0" ]; then
759         test_subtest_known_broken_=t
760     fi
761 }
762
763 test_expect_success () {
764         exec 1>&6 2>&7          # Restore stdout and stderr
765         if [ -z "$inside_subtest" ]; then
766                 error "bug in the test script: test_expect_success without test_begin_subtest"
767         fi
768         inside_subtest=
769         test "$#" = 1 ||
770         error "bug in the test script: not 1 parameters to test_expect_success"
771
772         if ! test_skip "$test_subtest_name"
773         then
774                 test_run_ "$1"
775                 run_ret="$?"
776                 # test_run_ may update missing external prerequisites
777                 test_check_missing_external_prereqs_ "$test_subtest_name" ||
778                 if [ "$run_ret" = 0 -a "$eval_ret" = 0 ]
779                 then
780                         test_ok_
781                 else
782                         test_failure_ "$1"
783                 fi
784         fi
785 }
786
787 test_expect_code () {
788         exec 1>&6 2>&7          # Restore stdout and stderr
789         if [ -z "$inside_subtest" ]; then
790                 error "bug in the test script: test_expect_code without test_begin_subtest"
791         fi
792         inside_subtest=
793         test "$#" = 2 ||
794         error "bug in the test script: not 2 parameters to test_expect_code"
795
796         if ! test_skip "$test_subtest_name"
797         then
798                 test_run_ "$2"
799                 run_ret="$?"
800                 # test_run_ may update missing external prerequisites,
801                 test_check_missing_external_prereqs_ "$test_subtest_name" ||
802                 if [ "$run_ret" = 0 -a "$eval_ret" = "$1" ]
803                 then
804                         test_ok_
805                 else
806                         test_failure_ "exit code $eval_ret, expected $1" "$2"
807                 fi
808         fi
809 }
810
811 # This is not among top-level (test_expect_success)
812 # but is a prefix that can be used in the test script, like:
813 #
814 #       test_expect_success 'complain and die' '
815 #           do something &&
816 #           do something else &&
817 #           test_must_fail git checkout ../outerspace
818 #       '
819 #
820 # Writing this as "! git checkout ../outerspace" is wrong, because
821 # the failure could be due to a segv.  We want a controlled failure.
822
823 test_must_fail () {
824         "$@"
825         test $? -gt 0 -a $? -le 129 -o $? -gt 192
826 }
827
828 # test_cmp is a helper function to compare actual and expected output.
829 # You can use it like:
830 #
831 #       test_expect_success 'foo works' '
832 #               echo expected >expected &&
833 #               foo >actual &&
834 #               test_cmp expected actual
835 #       '
836 #
837 # This could be written as either "cmp" or "diff -u", but:
838 # - cmp's output is not nearly as easy to read as diff -u
839 # - not all diff versions understand "-u"
840
841 test_cmp () {
842         $GIT_TEST_CMP "$@"
843 }
844
845 # This function can be used to schedule some commands to be run
846 # unconditionally at the end of the test to restore sanity:
847 #
848 #       test_expect_success 'test core.capslock' '
849 #               git config core.capslock true &&
850 #               test_when_finished "git config --unset core.capslock" &&
851 #               hello world
852 #       '
853 #
854 # That would be roughly equivalent to
855 #
856 #       test_expect_success 'test core.capslock' '
857 #               git config core.capslock true &&
858 #               hello world
859 #               git config --unset core.capslock
860 #       '
861 #
862 # except that the greeting and config --unset must both succeed for
863 # the test to pass.
864
865 test_when_finished () {
866         test_cleanup="{ $*
867                 } && (exit \"\$eval_ret\"); eval_ret=\$?; $test_cleanup"
868 }
869
870 test_done () {
871         GIT_EXIT_OK=t
872         test_results_dir="$TEST_DIRECTORY/test-results"
873         mkdir -p "$test_results_dir"
874         test_results_path="$test_results_dir/$this_test"
875
876         printf %s\\n \
877                 "success $test_success" \
878                 "fixed $test_fixed" \
879                 "broken $test_broken" \
880                 "failed $test_failure" \
881                 "total $test_count" \
882             > $test_results_path
883
884         [ -n "$EMACS_SERVER" ] && test_emacs '(kill-emacs)'
885
886         if [ "$test_failure" = "0" ]; then
887             if [ "$test_broken" = "0" ]; then
888                 rm -rf "$remove_tmp"
889             fi
890             exit 0
891         else
892             exit 1
893         fi
894 }
895
896 test_python () {
897     # Note: if there is need to print debug information from python program,
898     # use stdout = os.fdopen(6, 'w') or stderr = os.fdopen(7, 'w')
899     PYTHONPATH="$NOTMUCH_BUILDDIR/bindings/python-cffi/build/stage:$NOTMUCH_SRCDIR/bindings/python${PYTHONPATH:+:$PYTHONPATH}" \
900         $NOTMUCH_PYTHON -B - > OUTPUT
901 }
902
903 test_C () {
904     local exec_file test_file
905     exec_file="test${test_count}"
906     test_file="${exec_file}.c"
907     cat > ${test_file}
908     ${TEST_CC} ${TEST_CFLAGS} -I${NOTMUCH_SRCDIR}/test -I${NOTMUCH_SRCDIR}/lib -o ${exec_file} ${test_file} -L${NOTMUCH_BUILDDIR}/lib/ -lnotmuch -ltalloc
909     echo "== stdout ==" > OUTPUT.stdout
910     echo "== stderr ==" > OUTPUT.stderr
911     ./${exec_file} "$@" 1>>OUTPUT.stdout 2>>OUTPUT.stderr
912     notmuch_dir_sanitize OUTPUT.stdout OUTPUT.stderr | notmuch_exception_sanitize | notmuch_debug_sanitize > OUTPUT
913 }
914
915 test_private_C () {
916     local exec_file test_file
917     exec_file="test${test_count}"
918     test_file="${exec_file}.c"
919     echo '#include <notmuch-private.h>' > ${test_file}
920     cat >> ${test_file}
921     ${TEST_CC} ${TEST_CFLAGS} -I${NOTMUCH_SRCDIR}/test -I${NOTMUCH_SRCDIR}/lib -I${NOTMUCH_SRCDIR}/util -I${NOTMUCH_SRCDIR}/compat ${NOTMUCH_GMIME_CFLAGS} -o ${exec_file} ${test_file} ${NOTMUCH_BUILDDIR}/lib/libnotmuch.a ${NOTMUCH_GMIME_LDFLAGS} ${NOTMUCH_XAPIAN_LDFLAGS} ${NOTMUCH_BUILDDIR}/util/libnotmuch_util.a ${NOTMUCH_SFSEXP_LDFLAGS} ${NOTMUCH_BUILDDIR}/parse-time-string/libparse-time-string.a -ltalloc -lstdc++
922     echo "== stdout ==" > OUTPUT.stdout
923     echo "== stderr ==" > OUTPUT.stderr
924     ./${exec_file} "$@" 1>>OUTPUT.stdout 2>>OUTPUT.stderr
925     notmuch_dir_sanitize OUTPUT.stdout OUTPUT.stderr | notmuch_exception_sanitize | notmuch_debug_sanitize > OUTPUT
926 }
927
928 make_shim () {
929     local base_name test_file shim_file
930     base_name="$1"
931     test_file="${base_name}.c"
932     shim_file="${base_name}.so"
933     cat > ${test_file}
934     ${TEST_CC} ${TEST_CFLAGS} ${TEST_SHIM_CFLAGS} -I${NOTMUCH_SRCDIR}/test -I${NOTMUCH_SRCDIR}/lib -o ${shim_file} ${test_file} ${TEST_SHIM_LDFLAGS}
935 }
936
937 notmuch_with_shim () {
938     local base_name shim_file notmuch_cmd
939     if [ -n "${NOTMUCH_TEST_INSTALLED-}" ]; then
940         notmuch_cmd="notmuch"
941     else
942         notmuch_cmd="notmuch-shared"
943     fi
944     base_name=$1
945     shift
946     shim_file="${base_name}.so"
947     LD_PRELOAD=${LD_PRELOAD:+:$LD_PRELOAD}:./${shim_file} $notmuch_cmd "$@"
948 }
949
950 # Creates a script that counts how much time it is executed and calls
951 # notmuch.  $notmuch_counter_command is set to the path to the
952 # generated script.  Use notmuch_counter_value() function to get the
953 # current counter value.
954 notmuch_counter_reset () {
955         notmuch_counter_command="$TMP_DIRECTORY/notmuch_counter"
956         if [ ! -x "$notmuch_counter_command" ]; then
957                 notmuch_counter_state_path="$TMP_DIRECTORY/notmuch_counter.state"
958                 cat >"$notmuch_counter_command" <<EOF || return
959 #!/bin/sh
960
961 read count < "$notmuch_counter_state_path"
962 echo \$((count + 1)) > "$notmuch_counter_state_path"
963
964 exec notmuch "\$@"
965 EOF
966                 chmod +x "$notmuch_counter_command" || return
967         fi
968
969         echo 0 > "$notmuch_counter_state_path"
970 }
971
972 # Returns the current notmuch counter value.
973 notmuch_counter_value () {
974         if [ -r "$notmuch_counter_state_path" ]; then
975                 read count < "$notmuch_counter_state_path"
976         else
977                 count=0
978         fi
979         echo $count
980 }
981
982 test_reset_state_ () {
983         test -z "$test_init_done_" && test_init_
984
985         test_subtest_known_broken_=
986         test_subtest_missing_external_prereq_=()
987 }
988
989 # called once before the first subtest
990 test_init_ () {
991         test_init_done_=t
992
993         # skip all tests if there were external prerequisites missing during init
994         test_check_missing_external_prereqs_ "all tests in $this_test" && test_done
995 }
996
997
998 # Where to run the tests
999 if [[ -n "${NOTMUCH_BUILDDIR}" ]]; then
1000     TEST_DIRECTORY=$NOTMUCH_BUILDDIR/test
1001 else
1002     TEST_DIRECTORY=$NOTMUCH_SRCDIR/test
1003 fi
1004
1005 . "$NOTMUCH_SRCDIR/test/test-lib-common.sh" || exit 1
1006
1007 # Use -P to resolve symlinks in our working directory so that the cwd
1008 # in subprocesses like git equals our $PWD (for pathname comparisons).
1009 cd -P "$TMP_DIRECTORY" || error "Cannot set up test environment"
1010
1011 if test "$verbose" = "t"
1012 then
1013         exec 4>&2 3>&1
1014 else
1015         exec 4>test.output 3>&4
1016 fi
1017
1018 for skp in $NOTMUCH_SKIP_TESTS
1019 do
1020         to_skip=
1021         for skp in $NOTMUCH_SKIP_TESTS
1022         do
1023                 case "$this_test" in
1024                 $skp)
1025                         to_skip=t
1026                         break
1027                 esac
1028                 case "$this_test_bare" in
1029                 $skp)
1030                         to_skip=t
1031                         break
1032                 esac
1033         done
1034         case "$to_skip" in
1035         t)
1036                 say_color skip >&3 "skipping test $this_test altogether"
1037                 say_color skip "skip all tests in $this_test"
1038                 test_done
1039         esac
1040 done
1041
1042 # Provide an implementation of the 'yes' utility
1043 yes () {
1044         if test $# = 0
1045         then
1046                 y=y
1047         else
1048                 y="$*"
1049         fi
1050
1051         while echo "$y"
1052         do
1053                 :
1054         done
1055 }
1056
1057 # Fix some commands on Windows
1058 case $(uname -s) in
1059 *MINGW*)
1060         # Windows has its own (incompatible) sort and find
1061         sort () {
1062                 /usr/bin/sort "$@"
1063         }
1064         find () {
1065                 /usr/bin/find "$@"
1066         }
1067         sum () {
1068                 md5sum "$@"
1069         }
1070         # git sees Windows-style pwd
1071         pwd () {
1072                 builtin pwd -W
1073         }
1074         # no POSIX permissions
1075         # backslashes in pathspec are converted to '/'
1076         # exec does not inherit the PID
1077         ;;
1078 *)
1079         test_set_prereq POSIXPERM
1080         test_set_prereq BSLASHPSPEC
1081         test_set_prereq EXECKEEPSPID
1082         ;;
1083 esac
1084
1085 test -z "$NO_PERL" && test_set_prereq PERL
1086 test -z "$NO_PYTHON" && test_set_prereq PYTHON
1087
1088 # test whether the filesystem supports symbolic links
1089 ln -s x y 2>/dev/null && test -h y 2>/dev/null && test_set_prereq SYMLINKS
1090 rm -f y
1091
1092 # declare prerequisites for external binaries used in tests
1093 test_declare_external_prereq dtach
1094 test_declare_external_prereq emacs
1095 test_declare_external_prereq ${TEST_EMACSCLIENT}
1096 test_declare_external_prereq ${TEST_GDB}
1097 test_declare_external_prereq gpg
1098 test_declare_external_prereq openssl
1099 test_declare_external_prereq gpgsm
1100 test_declare_external_prereq ${NOTMUCH_PYTHON}
1101 test_declare_external_prereq xapian-metadata
1102 test_declare_external_prereq xapian-delve